# You can override the included template(s) by including variable overrides
# See https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#priority-of-environment-variables
image: docker:latest

services:
  - name: mongo:latest
    alias: dbsandbox
  - docker:dind

stages:
  - compile
  - verify
  - test
  - build
  - package

include:
  - template: Code-Quality.gitlab-ci.yml
  - template: Security/SAST.gitlab-ci.yml

code_quality_html:
  extends: code_quality
  variables:
    REPORT_FORMAT: html
  artifacts:
    paths: [gl-code-quality-report.html]

variables:
  MAVEN_CLI_OPTS: "--batch-mode"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"
  SAST_JAVA_VERSION: 11
  DOCKER_HOST: tcp://docker:2375
  MAVEN_HOME: "apache-maven-3.6.3"
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

before_script:
  - apk add --no-cache maven openjdk11 --repository=http://dl-cdn.alpinelinux.org/alpine/edge/community

cache:
  paths:
  - ".m2/repository/"

compile_job:
  stage: compile
  script:
    - ./mvnw $MAVEN_CLI_OPTS compile
  artifacts:
    expire_in: 120 min
    paths:
      - target/
      - "*/target"

verify_job:
  stage: verify
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - ./mvnw $MAVEN_CLI_OPTS verify sonar:sonar
  artifacts:
    expire_in: 120 min
    paths:
      - target/
      - "*/target"
  only:
    - merge_requests
    - master
    - develop

test_job:
  stage: test
  script:
    - find . -name "*.class" -exec touch {} \+
    - ./mvnw $MAVEN_CLI_OPTS test

build_job:
  stage: build
  script:
    - ./mvnw $MAVEN_CLI_OPTS clean package -Pnative -DskipTests -Dquarkus.native.container-build=true
  artifacts:
    expire_in: 120 min
    paths:
      - target/
      - "*/target"

package_job:
  stage: package
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -f src/main/docker/Dockerfile.native -t $CI_REGISTRY_IMAGE:0.1.0 .
    - docker tag $CI_REGISTRY_IMAGE:0.1.0 $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:0.1.0
  artifacts:
    expire_in: 120 min
    paths:
      - target/
      - "*/target"

sast:
  stage: test
